const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const expense_lines = sequelize.define(
    'expense_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      date: {
        type: DataTypes.DATE,
      },

      merchant: {
        type: DataTypes.TEXT,
      },

      amount: {
        type: DataTypes.DECIMAL,
      },

      currency: {
        type: DataTypes.TEXT,
      },

      category: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  expense_lines.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.expense_lines.belongsTo(db.expense_reports, {
      as: 'report',
      foreignKey: {
        name: 'reportId',
      },
      constraints: false,
    });

    db.expense_lines.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.expense_lines.hasMany(db.file, {
      as: 'receipt_ref',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.expense_lines.getTableName(),
        belongsToColumn: 'receipt_ref',
      },
    });

    db.expense_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.expense_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return expense_lines;
};
